<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' This routine calculates tax
'*********************************************************************************

sub CalculateTax (subtotal, total, shippingcost, tax, pst)
   dim rc
   dim taxdone, taxprice
   Tax = 0
   taxdone = false
   TaxCheckcustomerexcept dbc, rc ' is customer exempt
   if rc = 0 then ' yes then no tax
      exit sub
   end if

   ' the tax price can include shipping or discounts
   if GetConfig("xtaxincludeshipping") = "Yes" then
      taxprice = subtotal + shippingcost
   else
      if GetConfig("xtaxincludediscount") = "No" then
         taxprice = total
      else
         taxprice = subtotal
      end if
   end if

   ' some products are tax free, so we need to ReCalculate the real product total
   if GetConfig("xtaxexcludeproducts")<>"" or GetConfig("xtaxexcludeproductsdb")<>"" or GetConfig("xtaxfreeproducts") = "Yes" then
      taxCalculatenewsubtotal taxprice
	  
	  '6504 - BUG - Negative tax on certain conditions
	  if taxprice <= 0 then
         tax = 0
         exit sub
      end if

      if GetConfig("xtaxincludeshipping") = "Yes" then
         taxprice = taxprice+shippingcost
      end if
   end if

   if ucase(GetSess("country")) = "CA" then
      TaxbyCanada taxprice, tax, taxdone, dbc, pst
      if taxdone = True then
         exit sub
      end if
   end if

   ' Most common is tax by state
   TaxbyState taxprice, tax, taxdone, dbc
   if taxdone = True then
      exit sub
   end if

   '6504 - BUG FIXED - SHOPTAX.ASP EU VAT ISSUES
   TaxforEU taxprice, tax, taxdone, dbc
   if taxdone = true then
      exit sub
   end if

   Taxbycountry taxprice, tax, taxdone, dbc
   if taxdone = true then
      exit sub
   end if

   TaxbyProduct taxprice, tax, taxdone, dbc
end sub

' first get state. Some tax by shipping state and others by the ordering state
' Handle By State/Province
sub TaxbyState (price, tax, taxdone, dbc)
   dim state, taxsql, taxrs
   dim xfactor, xnet, rate
   if GetConfig("xtaxshippingstate") = "Yes" then
      state = GetSess("shipstate")
      if state = "" then
         state = GetSess("state")
      end if
   else
      state = GetSess("state")
   end if
   taxsql = "select * from shopstates where stateabbrev='" & state & "'"
   taxsql = taxsql & " and (statetaxrate <> 0 and statetaxrate is not null)"
   'set taxrs = dbc.execute(taxsql)
   Set taxrs = Server.CreateObject("ADODB.Recordset")
   taxrs.open taxsql, dbc, adOpenDynamic, adLockOptimistic
   if not taxrs.eof then ' this state taxes
      rate = taxrs("statetaxrate") ' get rate
      rate = csng(rate) ' convert to number
      ' if atx included in price this adjusts the tax value
      if GetConfig("xtaxincludedinprice") = "Yes" then
         xfactor = (rate * 100) + 100
         xnet = (price / xfactor) * 100
         tax = price - xnet
      else
         tax = rate * price
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet taxrs ' close tax recordset
end sub

' see if this country has a tax rate
' if yes calculate tax
sub TaxbyCountry (price, tax, taxdone, dbc)
   dim taxsql, taxrs, country
   dim xfactor, xnet, rate
   country = ucase(GetSess("country"))
   taxsql = "select * from shopcountries where country='" & country & "'"
   taxsql = taxsql & " and (countrytaxrate <> 0 and countrytaxrate is not null)"
   'set taxrs = dbc.execute(taxsql)
   Set taxrs = Server.CreateObject("ADODB.Recordset")
   taxrs.open taxsql, dbc, adOpenDynamic, adLockOptimistic
   if not taxrs.eof then ' this state taxes
      rate = taxrs("countrytaxrate") ' get rate
      rate = csng(rate) ' convert to number
      ' if atx included in price this adjusts the tax value
      if GetConfig("xtaxincludedinprice") = "Yes" then
         xfactor = (rate * 100) + 100
         xnet = (price / xfactor) * 100
         tax = price - xnet
      else
         tax = rate * price
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet taxrs ' close tax recordset
end sub

' We are now looking at tax by individual product
sub TaxbyProduct (iprice, tax, taxdone, dbc)
   dim taxfield, useproductdbc
   taxfield = GetConfig("xtaxbyproduct")
   if taxfield = "" then exit sub
   dim productname, quantity, price
   dim scartitem, ArrCart, productid, productcode, taxforitem
   dim taxamount
   dim i
   dim productql
   dim rsitem
   if GetConfig("xproductdb")<>"" then
      useproductdbc = true
   else
      useproductdbc = false
   end if

   ' go through each item in the cart
   ' get CatalogId and see if it is taxable
   scartItem = GetSess("CartCount") ' number of products
   ArrCart = GetSessa("CartArray")
   for i = 1 to scartItem
      productid = ArrCart(cProductid, i)
      productcode = ArrCart(cProductCode, i)
      productname = ArrCart(cProductname, i)
      quantity = ArrCart(cQuantity, i)
      Price = ArrCart(cUnitPrice, i)
      productql = "select * from products where CatalogId=" & productid
      if useproductdbc = false then
         'set rsItem = dbc.execute(Productql)
      else
         'set rsItem = dbc.execute(Productql)
      end if
      Set rsItem = Server.CreateObject("ADODB.Recordset")
      rsItem.open Productql, dbc, adOpenDynamic, adLockOptimistic
      taxforitem = 0
      if not rsItem.eof then
         if not isnull(rsitem(taxfield)) then
            taxamount = rsitem(taxfield)
            taxamount = csng(taxamount)
            TaxforItem = Quantity * Price * taxamount
         end if
      end if
      Tax = Tax + TaxForItem
      CloseRecordSet rsitem
   next
   taxdone = true
end sub

' 700 - Tax Inclusive/Exclusive Price Display
sub TaxbyProductID (tax, taxdone, iprice, productid)
   dim taxfield
   taxfield = GetConfig("xtaxbyproduct")
   if taxfield = "" then exit sub
   dim taxamount
   dim i
   dim productql
   dim rsitem
   dim Quantity

   productql = "select * from products where CatalogId=" & productid
   'set rsItem = dbc.execute(Productql)
   Set rsItem = Server.CreateObject("ADODB.Recordset")
   rsItem.open Productql, dbc, adOpenDynamic, adLockOptimistic
   Quantity = 1
   if not rsItem.eof then
      if not isnull(rsitem(taxfield)) then
         taxamount = rsitem(taxfield)
         taxamount = csng(taxamount)
         tax = Quantity * iprice * taxamount
      end if
   end if
   CloseRecordSet rsitem
   taxdone = true
end sub

' The last calculation is same as tax by country
' except that with a valid vat number, it could be tax exempt
sub TaxforEU (taxprice, tax, taxdone, dbc)
   ' This routine calculates tax foe EU countries
   ' If the order is for anyone in the country list above, set tax at 17.5%
   ' Inputs are
   dim xcountryname, xtaxrate
   dim xfactor, xnet
   if GetConfig("xTaxEu")<>"Yes" then exit sub
   taxdone = true
   ' No tax if valid vat number
   if GetSess("vatnumbertax")<>"" then exit sub
   ' treat it as a normal country
   TaxbyCountry taxprice, tax, taxdone, dbc
end sub

' Exclude some products such as gift certificates
sub TaxCalculatenewsubtotal (newsubtotal)
   dim scartItem, giftproductid
   dim ArrCart
   dim i
   dim ProdQuantity, prodprice
   dim foundproduct, productid
   dim products(100), productcount
   dim dbfield
   dbfield = GetConfig("xtaxexcludeproductsdb")
   if GetConfig("xtaxexcludeproducts")<>"" then
      ParseRecord GetConfig("xtaxexcludeproducts"), products, productcount, ","
      for i = 0 to productcount -1
         Products(i) = clng(products(i))
      next
   else
      productcount = 0
   end if
   scartItem = GetSess("cartcount")
   ArrCart = GetSessa("cartarray")

   newsubtotal = 0
   ' go through all products and add up the quantities
   for i = 1 to scartItem
      productid = ArrCart(cProductid, i)
      if isnumeric(productid) then
         productid = clng(productid)
      else
         productid = 0
      end if
      ProdQuantity = ArrCart(cQuantity, i)
      ProdPrice = ArrCart(cUnitPrice, i)
      foundproduct = false
      if productcount>0 then
         foundproduct = taxFindproduct(productid, products, productcount)
      end if
      if foundproduct = false then
         if dbfield<>"" or GetConfig("xtaxfreeproducts") = "Yes" then
            foundproduct = taxFindProductdb(productid, dbc, dbfield)
         end if
      end if
      if foundproduct = false then
         Newsubtotal = newsubtotal + ProdQuantity * ProdPrice
      end if
   next

   '6.50.4 Bugs Fix - 08 October 2008
   if GetSess("discount") <> "" then
      if isnumeric(GetSess("discount")) and newsubtotal > 0 then
         newsubtotal = newsubtotal - GetSess("discount")
      end if
   end if

   if GetSess("coupondiscount") <> "" then
      if isnumeric(GetSess("coupondiscount")) and newsubtotal > 0 then
         newsubtotal = newsubtotal - GetSess("coupondiscount")
      end if
   end if
end sub

function TaxFindProduct (productid, products, productcount)
   dim i
   for i = 0 to productcount -1
      if productid = products(i) then
         taxfindproduct = true
         exit function
      end if
   next
   taxfindproduct = false
end function

' Find product in Database
' if field in taxexemptfieldd is not null it is taxexempt
' or in 6.50 it can be marked taxfree in the product record
function TaxFindProductDB (productid, dbc, taxfield)
   dim productsql, rsItem, taxvalue, found
   found = false
   productsql = "select * from products where CatalogId=" & productid
   'set rsItem = dbc.execute(Productsql)
   Set rsItem = Server.CreateObject("ADODB.Recordset")
   rsItem.open Productsql, dbc, adOpenDynamic, adLockOptimistic
   if not rsItem.eof then
      if taxfield<>"" then
         taxvalue = rsitem(taxfield)
         if not isnull(taxvalue) then
            found = true
         end if
      end if

      '6.50.1 - fix check for tax free products
      if GetConfig("Xtaxfreeproducts") = "Yes" then
         taxvalue = rsitem("taxfree")
         if taxvalue then
            found = True
         end if
      end if
   end if
   CloseRecordSet rsitem
   TaxFindProductdb = found
end function

' see if this customer is taxexmpt
' set rc=0 if yes
' If using split Databases then open customerdb
sub TaxCheckcustomerexcept (dbc, rc)
   dim custsql, custrs
   if GetSess("CustomerID") = "" then exit sub ' no customer
   custsql = "select taxexempt from customers where contactid = " & GetSess("CustomerID")
   'set custrs = dbc.execute(custsql)
   Set custrs = Server.CreateObject("ADODB.Recordset")
   custrs.open custsql, dbc, adOpenDynamic, adLockOptimistic
   if not custrs.eof then
      if lcase(custrs("taxexempt")) = "yes" or lcase(custrs("taxexempt")) = "true" then
         rc = 0
      else
         rc = 4
      end if
   end if
   CloseRecordSet custrs
end sub

' Canadian Tax Handling
sub TaxbyCanada(price, tax, taxdone, dbc, pst)
   dim castate, cataxsql, cataxrs
   dim caxfactor, caxnet, carate, capst
   if GetConfig("xtaxshippingstate") = "Yes" then
      castate = GetSess("shipstate")
      if castate = "" then
         castate = GetSess("state")
      end if
   else
      castate = GetSess("state")
   end if
   cataxsql = "select * from shopstates where stateabbrev='" & castate & "'"
   cataxsql = cataxsql & " and (statetaxrate <> 0 and statetaxrate is not null)"
   'set cataxrs = dbc.execute(cataxsql)
   Set cataxrs = Server.CreateObject("ADODB.Recordset")
   cataxrs.open cataxsql, dbc, adOpenDynamic, adLockOptimistic
   if not cataxrs.eof then ' this state taxes
      carate = cataxrs("statetaxrate") ' get rate
      carate = csng(carate) ' convert to number
      capst = cataxrs("statecanadapst")
      if capst > "" then
         capst = csng(capst) ' convert to number
      end if

      if capst > "" then
         '6.50.1 - special cases for tax
         if GetConfig("xtaxincludedinprice") = "Yes" then
            if lcase(castate) = "qc" or lcase(castate) = "pe" then
               caxfactor = (capst * 100) + 100
               caxnet = (price / caxfactor) * 100
               capst = price - caxnet
               caxfactor = (carate * 100) + 100
               caxnet = ((price + capst) / caxfactor) * 100
               tax = (price + capst) - caxnet
            else
               caxfactor = (carate * 100) + 100
               caxnet = (price / caxfactor) * 100
               tax = price - caxnet
               caxfactor = (capst * 100) + 100
               caxnet = (price / caxfactor) * 100
               capst = price - caxnet
            end if
         else
            if lcase(castate) = "qc" or lcase(castate) = "pe" then
               pst = capst * price
               tax = carate * (price + pst)
            else
               tax = carate * price
               pst = capst * price
            end if
         end if
      else
         ' if atx included in price this adjusts the tax value
         if GetConfig("xtaxincludedinprice") = "Yes" then
            caxfactor = (carate * 100) + 100
            caxnet = (price / caxfactor) * 100
            tax = price - caxnet
         else
            tax = carate * price
         end if
      end if
      taxdone = true 'finished
   end if
   CloseRecordSet cataxrs ' close tax recordset
end sub
%>