<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Google map routines
'*********************************************************************************

' Display Google Map
Sub Displaygooglemap
   '700 - 2010.05.21 - Enhancement: Hide Google Map is in SSL mode
   '701 - 2010.11.30 - Bug Fix: Possible https issue with google map and tynt
   '701 - 2010.11.30 - Enhancement: Support HTTP_CLUSTER_HTTPS for secured mode
   if lcase(request.ServerVariables("HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_X_HTTPS")) = "on" or lcase(request.ServerVariables("HTTP_CLUSTER_HTTPS")) = "on" then exit sub

   if getconfig("xgooglemap")<>"Yes" then exit sub
   if getconfig("xgooglemaplatitude")="" or isnull(getconfig("xgooglemaplatitude")) then exit sub
   if getconfig("xgooglemaplongitude")="" or isnull(getconfig("xgooglemaplongitude")) then exit sub
   if getconfig("xgooglemapapikey")="" or isnull(getconfig("xgooglemapapikey")) then exit sub
   dim comprs
   dim sqlcomp
   dim sql
   dim googlemaprs
   dim fieldtype
   dim strgoogleAPIkey
   dim strlat
   dim strlng
   dim strzoomlevel
   dim strwidth
   dim strheight
   dim strname
   dim strphone
   dim straddress
   dim strcity
   dim strstate
   dim strzip
   dim stremail

   'get the google API Key from config value
   strgoogleAPIkey = getconfig("xgooglemapapikey")
   strlat = getconfig("xgooglemaplatitude")
   strlng = getconfig("xgooglemaplongitude")
   strzoomlevel = getconfig("xgooglemapzoomlevel")
   strwidth = getconfig("xgooglemapwidth")
   strheight = getconfig("xgooglemapheight")

   'set width and height of map to default value 300x300 if strwidth and strheight fields value is empty 
   if strwidth = "" or isnull(strwidth) then strwidth = 500
   if strheight = "" or isnull(strheight) then strheight = 300
		
   'set zoom level to default value 15 if strzoomlevel field value is empty
   if strzoomlevel = "" or isnull(strzoomlevel) then strzoomlevel = 4

   'get company profile value from table my company to display it in google map marker detail
   sqlcomp = "select * from mycompany"
   openRecordSet dbc, comprs, sqlcomp
   if not comprs.eof then
	  strname = trim(comprs("companyname"))
	  strphone = trim(comprs("phonenumber"))
	  straddress = trim(comprs("address"))
	  strcity = trim(comprs("city"))
	  strstate = trim(comprs("state"))
	  strzip = trim(comprs("postalcode"))
	  stremail = trim(comprs("myemail"))
   end if
   closerecordset comprs

   'display google map if latitude and longitude coordinate is not empty to start draw the map
   if strlat <> ""  and strlng <> "" then
	%>
	<!-- Code API Key below -->
	<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<%=strgoogleAPIkey%>" type="text/javascript"></script>
	<script type="text/javascript">
	window.onload=load;
	window.onunload=GUnload;
	//<![CDATA[
	var map = null;
	
			  // Function to create the marker and set up the event window
		  function createMarker(point,name,phone,address,city,state,zip,url) {
			// Create the HTML text based on the values passed in from XML
			var markerhtml = "";
			if (name != "") markerhtml += "<span class='fontbold'>" + name + "</span><br>";
			markerhtml += address + "<br>" + city + ", " + state + " " + zip + "<br>";
			if (phone != "") markerhtml += "Phone: " + phone + "<br>";
			if (url != "") markerhtml += "<a href=\"mailto:" + url + "\">" + url + "</a>";
			
			// Create the map marker
			var blueIcon = new GIcon(G_DEFAULT_ICON);
			blueIcon.image = "<%=getconfig("xGoogleMapMarkerImage")%>";
			markerOptions = { icon:blueIcon };
			
			var marker = new GMarker(point,markerOptions);
			// Add a click event to each marker which will open the HTML window
			GEvent.addListener(marker, "click", function() {
			  marker.openInfoWindowHtml(markerhtml);
			});
			return marker;
		  }

	
	function load() {
		if (GBrowserIsCompatible()) {
		
		  
	
		  // Create the map
		  map = new GMap2(document.getElementById("googlemap"));
		  // Add controls for moving and zooming the map.  Use GSmallMapControl for small maps
		  map.addControl(new GLargeMapControl());
		  // Add controls for switching between regular and satellite views
		  map.addControl(new GMapTypeControl());
		  // Set the starting position and zoom level when the map loads
		  map.setCenter(new GLatLng(<%=strlat%>, <%=strlng%>), <%=strzoomlevel%>);
	
		var lat = "<%=strlat%>";
		var lng = "<%=strlng%>";
		var point = new GLatLng(lat,lng);
		var name = "<%=strname%>";
		var phone = "<%=strphone%>";
		var address = "<%=straddress%>";
		var city = "<%=strcity%>";
		var state = "<%=strstate%>";
		var zip = "<%=strzip%>";
		var url = "<%=stremail%>";
		// Call the function to create the marker
		var marker = createMarker(point,name,phone,address,city,state,zip,url);
		map.addOverlay(marker);
	
		  
		}
		// Javascript alert for older browsers where Google Maps isn't supported
		else {
		  alert("Sorry, the Google Map API is not compatible with this browser");
		}
	}
	//]]>
	</script>
	<h2><%=getlang("langgooglemap")%></h2>
	<div id="contactgooglemap" class="ac">
		<div id="googlemap" style="width: <%=strwidth%>px; height: <%=strheight%>px"></div>
	</div>
	<%
   end if
end sub
%>